%global debug_package %{nil}

Summary:       Stand-alone memory tester for x86 and x86-64 computers
Name:          memtest86+
Version:       5.31b
Release:       4%{?dist}
License:       GPLv2
URL:           http://www.memtest.org
Source0:       http://www.memtest.org/download/%{version}/%{name}-%{version}.tar.gz
Source1:       memtest-setup
Source2:       20_memtest86+
Source3:       memtest-setup.8
Source4:       memtest86+.conf

Patch3000:     memtest86+-5.31b-serial-console-fix.patch
Patch3001:     memtest86+-5.31b-gcc-12-fix.patch

BuildRequires: make gcc
Requires:      sed coreutils

ExclusiveArch: x86_64

%description
Memtest86+ is a stand-alone memory tester for x86 and x86-64 architecture
computers. It provides a more thorough memory check than that provided by
BIOS memory tests. Memtest86+ can be loaded and run either directly by a
PC BIOS (legacy or UEFI) or via an intermediate bootloader that supports
the Linux 16-bit, 32-bit, 64-bit, or EFI handover boot protocol. It should
work on any Pentium class or later 32-bit or 64-bit x86 CPU.

%prep
%autosetup -n %{name}-%{version} -p1
%ifarch x86_64
sed -i -e's,$(LD) -s -T memtest.lds,$(LD) -s -T memtest.lds -z max-page-size=0x1000,' Makefile
%endif

%build
%make_build

%install
mkdir -p %{buildroot}/{boot,%{_sbindir}}
install -m644 memtest %{buildroot}/boot/elf-%{name}-%{version}
install -m644 memtest.bin %{buildroot}/boot/%{name}-%{version}
install -m755 %{SOURCE1} %{buildroot}%{_sbindir}/memtest-setup
mkdir -p %{buildroot}%{_sysconfdir}/grub.d
touch %{buildroot}%{_sysconfdir}/grub.d/20_memtest86+
install -Dd %{buildroot}%{_datadir}/%{name}
install -m644 %{SOURCE2} %{buildroot}%{_datadir}/%{name}
install -Dpm 0644 %{SOURCE3} %{buildroot}%{_mandir}/man8/memtest-setup.8
install -Dpm 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/memtest86+.conf

%files
%config(noreplace) %{_sysconfdir}/memtest86+.conf
/boot/%{name}-%{version}
/boot/elf-%{name}-%{version}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/20_memtest86+
%ghost %attr(0755,-,-) %{_sysconfdir}/grub.d/20_memtest86+
%{_sbindir}/memtest-setup
%{_mandir}/man8/*.8.gz

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.31b-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.31b-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.31b-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Sep 23 2022 ZoeDong <zoedong@tencent.com> - 5.31b-1
- Initial build
